/*
 * CiaoBlock.h
 *
 *  Created on: Jun 9, 2014
 *      Author: umer
 */

#ifndef CIAOBLOCK_H_
#define CIAOBLOCK_H_


#include "llvm/IR/Instructions.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/IR/Constants.h"

#include "Globals.h"
#include "CiaoLiteral.h"

#include <vector>
#include <set>

using namespace std;
using namespace llvm;

namespace LLVM2CIAO {

class CiaoBlock {
	BasicBlock * llvmBlock;
	std::vector<CiaoLiteral*> CiaoLiterals;

	set<string> inLive;
	set<string> outLive;
	set<string> outputVars;
	void clearLiterals();

public:
	CiaoBlock();
	CiaoBlock(BasicBlock * BB);

	~CiaoBlock();

	void addLiteral(CiaoLiteral * lit); //add before tail
	void addLiteralAtTail(CiaoLiteral * lit);
	CiaoLiteral * removeLiteralAtTail();
	void addLiteralAtHead(CiaoLiteral * lit);
	//bool removePhi(std::string & b1, CiaoLiteral ** lit1, std::string & b2, CiaoLiteral ** lit2, CiaoLiteral ** phiLit, int &phiLitIndex, string & newVar);
	vector< pair<string,CiaoLiteral *> > removePhi(CiaoLiteral ** phiLit, int &phiLitIndex, string & newVar);
	bool replaceLiteral(int i, CiaoLiteral* lit);
	set<string> kill();
	set<string> gen();

	vector<string> succ();
	string getJumpVar();
	void addinLive(set<string> inlive);
	void setinLive(set<string> il);
	set<string> getinLive();
	void setoutputVars(set<string> ov);
	void insert_outputVar(string var);
	set<string> getoutputVars();
	void setoutLive(set<string> il);
	set<string> getoutLive();

	string getName();
	string getMergedBlockName();
	set<string> getMergedBlockInputArgs();
	void setllvmBlock(BasicBlock* BB);
	string toClauseHead();
	string getBlockCall();
	string toClauseBody();
	void print(raw_ostream &O);
	bool hasRetStmt();
	string getRetStmtVar();
};

}

#endif /* CIAOBLOCK_H_ */
