/*
 * CiaoLiteral.cpp
 *
 *  Created on: Jun 9, 2014
 *      Author: umer
 */

#include "CiaoLiteral.h"

namespace LLVM2CIAO {


CiaoLiteral::CiaoLiteral(Instruction * I)
{		//CIS.clear();
	//CIS.TestAndEraseFromSet
	this->llvmInstr=I;
}

CiaoLiteral::CiaoLiteral()
{
	llvmInstr=NULL;
}

CiaoLiteral::~CiaoLiteral()
{
}


Instruction * CiaoLiteral::getllvmInstr()
{
	return llvmInstr;
}

 set<string> CiaoLiteral::def()
{
	set<string> defset;
	if(!llvmInstr)
		return defset;

	if(llvmInstr->hasName())    // If an instruction outputs result
	{
		//Type and name of instruction value(what instruction returns)
		//errs()<<"\n     "<<*(I->getType() )<<" "<<I->getName();
		defset.insert(llvmInstr->getName());
	}
	return defset;
}
 set<string> CiaoLiteral::ref()
{
	set<string> refset;
	if(!llvmInstr)
		return refset;
//		string allocaName=llvmInstr->getOpcodeName();
//		if(allocaName=="alloca")
//			return refset;

	if(isa<BranchInst>(llvmInstr))
	{
		BranchInst * BI = dyn_cast<BranchInst>(llvmInstr);
		if(llvmInstr->getNumOperands()>0 && BI->getNumSuccessors()>1)
			refset.insert(llvmInstr->getOperand(0)->getName());
	}
	else if(isa<CallInst>(llvmInstr))
	{
		CallInst * CI = dyn_cast<CallInst>(llvmInstr);
		for(unsigned int i=0;i<CI->getNumArgOperands();i++)
		{
			//errs()<<*(llvmInstr->getOperand(i) ->getType())<<" ";
			if(!(CI->getOperand(i)->hasName()))
			{ //Cases when operand does not have a name:
			}
			else
			{
				//errs()<<llvmInstr->getOperand(i)->getName()<<",";
				//main.append(llvmInstr->getOperand(i)->getName());
				refset.insert(CI->getOperand(i)->getName());
			}
		}
	}
	else
	{
		for(unsigned int i=0;i<llvmInstr->getNumOperands();i++)
		{
			//errs()<<*(llvmInstr->getOperand(i) ->getType())<<" ";
			if(!(llvmInstr->getOperand(i)->hasName()))
			{ //Cases when operand does not have a name:
			}
			else
			{
				//errs()<<llvmInstr->getOperand(i)->getName()<<",";
				//main.append(llvmInstr->getOperand(i)->getName());
				refset.insert(llvmInstr->getOperand(i)->getName());
			}
		}
	}
	return refset;
}
 void CiaoLiteral::print()
{
	errs()<<"\t\t"<<toLiteral()<<"\n";
}

bool CiaoLiteral::isPhi()
{
	if(llvmInstr!=NULL)
		return llvmInstr->getOpcode()==Instruction::PHI;
	return false;
}

bool CiaoLiteral::isRet()
{
	if(llvmInstr!=NULL)
		return (llvmInstr->getOpcode()==Instruction::Ret&&llvmInstr->getNumOperands()>0);
	return false;
}
string CiaoLiteral::getRetStmtVar()
{
	string retVar;
	if(isRet() && llvmInstr->getNumOperands()>0)
		retVar=llvmInstr->getOperand(0)->getName();
	return retVar;
}
void CiaoLiteral::instruction_info(string &instr, set<string> &def,set<string> &ref)
{

	switch(llvmInstr->getOpcode())
	{
		case Instruction::ICmp:
		{
			//HANDLE_OTHER_INST(46, ICmp   , ICmpInst   )  // Integer comparison instruction
			if (isa<ICmpInst>(llvmInstr))
			{
				//int s = ( (ICmpInst) *(llvmInstr)).getPredicate();
				ICmpInst::Predicate pred =dyn_cast<ICmpInst>(llvmInstr)->getPredicate();
				switch(pred)
				{
					case ICmpInst::ICMP_EQ:    // 32,  ///< equal=
						instr="icmp_eq"; break;
					case ICmpInst::ICMP_NE:    // 33,  ///< not equal
						instr="icmp_ne"; break;
					case ICmpInst::ICMP_UGT:   // 34,  ///< unsigned greater than
						instr="icmp_ugt"; break;
					case ICmpInst::ICMP_UGE:   // 35,  ///< unsigned greater or equal
						instr="icmp_uge"; break;
					case ICmpInst::ICMP_ULT:   // 36,  ///< unsigned less than
						instr="icmp_ult"; break;
					case ICmpInst::ICMP_ULE:   // 37,  ///< unsigned less or equal
						instr="icmp_ule"; break;
					case ICmpInst::ICMP_SGT:   // 38,  ///< signed greater than
						instr="icmp_sgt"; break;
					case ICmpInst::ICMP_SGE:   // 39,  ///< signed greater or equal
						instr="icmp_sge"; break;
					case ICmpInst::ICMP_SLT:   // 40,  ///< signed less than
						instr="icmp_slt"; break;
					case ICmpInst::ICMP_SLE:   // 41,  ///< signed less or equal
						instr="icmp_sle"; break;
					default :
						true;
				}
			}
			break;
		}

		case Instruction::Br:
		{
			if(isa<BranchInst>(llvmInstr))
			{
				BranchInst * BI = dyn_cast<BranchInst>(llvmInstr);

				//errs()<<"\n==> parent = "<<llvmInstr->getParent()->getName();
				//errs()<< "\n=====> succ1 = "<<dyn_cast<BranchInst>(llvmInstr)->getSuccessor(0)->getName();
				//main.append(BI->getSuccessor(0)->getName());
				//BI->getSuccessor(0)->getName()
				if(BI->getNumSuccessors()>1) //If conditional branch
				{
					//errs()<< "\n=====> succ2 = "<<dyn_cast<BranchInst>(llvmInstr)->getSuccessor(1)->getName();
//						main.append("_");
//						main.append(BI->getSuccessor(1)->getName());
//
//
//						main.append(instr);

//					main.append("(");
//					//main.append(LiteralInputArgsList.front().transformArg(this->llvmInstr).second);
//					main.append(LiteralInputArgsList.front().transformArg().second);
//					main.append(" ");
				}
				else
				{
					//main.append(instr);
					//main.append("( ");
				}
				//instr=(string)llvmInstr->getOpcodeName();

			}
			else
			{
				//////////errs()<<"Serious BUG in case Instruction::Br: in function toLiteral()";
				exit(0);
			}
			break;
		}

		case Instruction::ExtractValue:
		{
			//errs()<<"extractvalue---";

			//ExtractValueInst EVI = dyn_cast<ExtractValueInst>(llvmInstr);
			ExtractValueInst * EVI = dyn_cast<ExtractValueInst>(llvmInstr);


			instr=(string)EVI->getOpcodeName();

			//main.append(instr);
			//main.append("(");
			break;
		}

		case Instruction::Store:
		{
			StoreInst * storeInst = dyn_cast<StoreInst>(llvmInstr);

			//LiteralInputArgsList.push_back(new CiaoArg(storeInst->getOperand(0)));
			//LiteralOutputArg = new CiaoArg(storeInst->getOperand(1));

			//	for(unsigned int i=0;i<llvmInstr->getNumOperands();i++)
			//		{
			//			ca = new CiaoArg(llvmInstr->getOperand(i));
			//			LiteralInputArgsList.push_back(ca);
			//		}


			/* FALL THROUGH */

			//break;
		}

		case Instruction::FCmp:
			/* FALL THROUGH */
			//HANDLE_OTHER_INST(47, FCmp   , FCmpInst   )  // Floating point comparison instr.

		case Instruction::PHI:
			/* FALL THROUGH */
			//HANDLE_OTHER_INST(48, PHI    , PHINode    )  // PHI node instruction

	//
	//	HANDLE_OTHER_INST(49, Call   , CallInst   )  // Call a function
	//	HANDLE_OTHER_INST(50, Select , SelectInst )  // select instruction
	//	HANDLE_OTHER_INST(51, UserOp1, Instruction)  // May be used internally in a pass
	//	HANDLE_OTHER_INST(52, UserOp2, Instruction)  // Internal to passes only
	//	HANDLE_OTHER_INST(53, VAArg  , VAArgInst  )  // vaarg instruction
	//	HANDLE_OTHER_INST(54, ExtractElement, ExtractElementInst)// extract from vector
	//	HANDLE_OTHER_INST(55, InsertElement, InsertElementInst)  // insert into vector
	//	HANDLE_OTHER_INST(56, ShuffleVector, ShuffleVectorInst)  // shuffle two vectors.
	//	HANDLE_OTHER_INST(57, ExtractValue, ExtractValueInst)// extract from aggregate
	//	HANDLE_OTHER_INST(58, InsertValue, InsertValueInst)  // insert into aggregate
	//	HANDLE_OTHER_INST(59, LandingPad, LandingPadInst)  // Landing pad instruction.
	//


		case Instruction::ExtractElement:
			/* FALL THROUGH */

			//Block Terminators

		case Instruction::Ret:
			/* FALL THROUGH */

		case Instruction::Switch:
			/* FALL THROUGH */

		case Instruction::IndirectBr:
			/* FALL THROUGH */

		case Instruction::Invoke:
			/* FALL THROUGH */

		case Instruction::Resume:
			/* FALL THROUGH */

		case Instruction::Unreachable:
			/* FALL THROUGH */

				//Binary operations

		case Instruction::Add:
			/* FALL THROUGH */

		case Instruction::FAdd:
			/* FALL THROUGH */

		case Instruction::Sub:
			/* FALL THROUGH */

		case Instruction::FSub:
			/* FALL THROUGH */

		case Instruction::Mul:
			/* FALL THROUGH */

		case Instruction::FMul:
			/* FALL THROUGH */

		case Instruction::UDiv:
			/* FALL THROUGH */

		case Instruction::SDiv:
			/* FALL THROUGH */

		case Instruction::FDiv:
			/* FALL THROUGH */

		case Instruction::URem:
			/* FALL THROUGH */

		case Instruction::SRem:
			/* FALL THROUGH */

		case Instruction::FRem:
			/* FALL THROUGH */

		default:
		{

			instr=(string)llvmInstr->getOpcodeName();

		}

	} //Switch ends

//		main.append(instr);
//		main.append("(");

	//Instruction operands
	for(unsigned int i=0;i<llvmInstr->getNumOperands();i++)
	{
		//errs()<<*(llvmInstr->getOperand(i) ->getType())<<" ";

		if(!(llvmInstr->getOperand(i)->hasName()))
		{ //Cases when operand does not have a name:
		  // 1) Constant operand
			if (ConstantInt *CI = dyn_cast<ConstantInt>(llvmInstr->getOperand(i)))
				if (CI->getBitWidth()<=64) //Checking for integer bits
				{
					//errs() << CI->getSExtValue()<<",";

					std::stringstream str;
					string s;
					str<<CI->getSExtValue();
					str>>s;

					//main.append(s);
				}
		}
		else
		{
			//errs()<<llvmInstr->getOperand(i)->getName()<<",";
			//main.append(llvmInstr->getOperand(i)->getName());
		}

	}

	//Output Argument
	if(llvmInstr->hasName())    // If an instruction outputs result
	{
		//Type and name of instruction value(what instruction returns)
		//errs()<<"\n     "<<*(llvmInstr->getType() )<<" "<<I->getName();
//			main.append(",");
//			main.append(llvmInstr->getName());
	}

//		main.append(")");
	return ;
}

string CiaoLiteral::icmp2literal()
{
	string instr;
	Instruction * I = llvmInstr;
	//HANDLE_OTHER_INST(46, ICmp   , ICmpInst   )  // Integer comparison instruction
	if (isa<ICmpInst>(I))
	{
		//int s = ( (ICmpInst) *(llvmInstr)).getPredicate();
		ICmpInst::Predicate pred =dyn_cast<ICmpInst>(I)->getPredicate();
		switch(pred)
		{
			case ICmpInst::ICMP_EQ:    // 32,  ///< equal=
				instr="icmp_eq"; break;
			case ICmpInst::ICMP_NE:    // 33,  ///< not equal
				instr="icmp_ne"; break;
			case ICmpInst::ICMP_UGT:   // 34,  ///< unsigned greater than
				instr="icmp_ugt"; break;
			case ICmpInst::ICMP_UGE:   // 35,  ///< unsigned greater or equal
				instr="icmp_uge"; break;
			case ICmpInst::ICMP_ULT:   // 36,  ///< unsigned less than
				instr="icmp_ult"; break;
			case ICmpInst::ICMP_ULE:   // 37,  ///< unsigned less or equal
				instr="icmp_ule"; break;
			case ICmpInst::ICMP_SGT:   // 38,  ///< signed greater than
				instr="icmp_sgt"; break;
			case ICmpInst::ICMP_SGE:   // 39,  ///< signed greater or equal
				instr="icmp_sge"; break;
			case ICmpInst::ICMP_SLT:   // 40,  ///< signed less than
				instr="icmp_slt"; break;
			case ICmpInst::ICMP_SLE:   // 41,  ///< signed less or equal
				instr="icmp_sle"; break;
			default :
				//true;
				errs()<<"ERROR:toLiteral()::::::Other enumeration values for ICMP must be added in more cases\n";
		}

	}
	return instr;

}

string CiaoLiteral::call2literal()
{
	string instr="";
	Instruction * I = llvmInstr;
	if(isa<CallInst>(I))
	{
		CallInst * CI = dyn_cast<CallInst>(I);
		string funcName = CI->getCalledFunction()->getName();
		instr+=funcName+"(";
		if(CI->hasName())
			instr+=transformArg(CI->getName())+", ";

		for(int i=0;i<CI->getNumArgOperands();i++)
		{
			if(CI->getArgOperand(i)->hasName())
				instr+=transformArg(CI->getArgOperand(i)->getName())+", ";
			else if (ConstantInt *CInt = dyn_cast<ConstantInt>(CI->getArgOperand(i)))
			{
				if (CInt->getBitWidth()<=64) //Checking for integer bits

				{
					std::stringstream str;
					string s;
					str<<CInt->getSExtValue();
					str>>s;
					instr+=s+", ";
				}
			}
			else if (ConstantExpr* gep = dyn_cast<ConstantExpr>(CI->getArgOperand(i)))
			{
				if (GlobalVariable* global = dyn_cast<GlobalVariable>(gep->getOperand(0)))
				{
					if (ConstantDataArray* array = dyn_cast<ConstantDataArray>(global->getInitializer()))
					{
						if (array->isCString())
						{
							//errs()<<"String is "<<array->getAsCString()<<"\n\n";
							instr+="\""+ string(array->getAsCString())+"\", ";
						}
					}
				}
			}
			else
				errs()<<"Warning:: function "+funcName+" has unnammed argument. Ignored. \n";
		}
		instr.resize(instr.size()-2);
		instr+=")";
	}
	return instr;
}

string CiaoLiteral::branch2literal()
{
	string instr;
	Instruction * I = llvmInstr;
	if(isa<BranchInst>(I))
	{
		BranchInst * BI = dyn_cast<BranchInst>(I);

		//errs()<<"\n==> parent = "<<llvmInstr->getParent()->getName();
		//errs()<< "\n=====> succ1 = "<<dyn_cast<BranchInst>(llvmInstr)->getSuccessor(0)->getName();
		//main.append(BI->getSuccessor(0)->getName());
		//BI->getSuccessor(0)->getName()
		set<string> inputArgs;
		instr=transformBlockName(mergedBlocksNames[prefixedBlockName(BI->getSuccessor(0))].first);
		inputArgs = mergedBlocksNames[prefixedBlockName(BI->getSuccessor(0))].second;
		string args="";
		for (set<string>::iterator it=inputArgs.begin(); it!=inputArgs.end(); ++it)
		{
			string var=*it;
			args+=transformArg(var)+", ";
		}

		if(!inputArgs.empty())
		{
			instr+="("+args;
			instr[instr.size()-2]=')';
			instr.resize(instr.size()-1);
			//instr+=".";
		}
//			else
//				//instr+=".";
	}
	else
	{
		//////////errs()<<"Serious BUG in case Instruction::Br: in function toLiteral()";
		errs()<<"\n ERROR: BUG in case Instruction::Br: in function toLiteral()\n";
		exit(0);
	}
	return instr;
}

string CiaoLiteral::toLiteral()
{
	string main;
	string instr;
	Instruction * I =llvmInstr;
	if(I==NULL)
	{
		errs()<<"LLVM Instr is null. exiting from cLitera:toLiteral()";
		exit(0);
	}

	switch(I->getOpcode())
	{


	//	for(unsigned int i=0;i<llvmInstr->getNumOperands();i++)
	//		{
	//			ca = new CiaoArg(llvmInstr->getOperand(i));
	//			LiteralInputArgsList.push_back(ca);
	//		}

		case Instruction::ICmp:
		{
			instr=icmp2literal();
			break;
		}

		case Instruction::Br:
		{
			return branch2literal();
			break;
		}
		case Instruction::Call:
		{
			return call2literal();
		}

		case Instruction::ExtractValue:
		{
			//errs()<<"extractvalue---";

			//ExtractValueInst EVI = dyn_cast<ExtractValueInst>(llvmInstr);
			ExtractValueInst * EVI = dyn_cast<ExtractValueInst>(I);


			instr=(string)EVI->getOpcodeName();

			main.append(instr);
			//main.append("(");
			break;
		}

		case Instruction::Store:
		{
			StoreInst * storeInst = dyn_cast<StoreInst>(I);

			//LiteralInputArgsList.push_back(new CiaoArg(storeInst->getOperand(0)));
			//LiteralOutputArg = new CiaoArg(storeInst->getOperand(1));

			//	for(unsigned int i=0;i<llvmInstr->getNumOperands();i++)
			//		{
			//			ca = new CiaoArg(llvmInstr->getOperand(i));
			//			LiteralInputArgsList.push_back(ca);
			//		}


			/* FALL THROUGH */

			//break;
		}

		case Instruction::FCmp:
			/* FALL THROUGH */
			//HANDLE_OTHER_INST(47, FCmp   , FCmpInst   )  // Floating point comparison instr.

		case Instruction::PHI:
			/* FALL THROUGH */
			//HANDLE_OTHER_INST(48, PHI    , PHINode    )  // PHI node instruction

	//
	//	HANDLE_OTHER_INST(49, Call   , CallInst   )  // Call a function
	//	HANDLE_OTHER_INST(50, Select , SelectInst )  // select instruction
	//	HANDLE_OTHER_INST(51, UserOp1, Instruction)  // May be used internally in a pass
	//	HANDLE_OTHER_INST(52, UserOp2, Instruction)  // Internal to passes only
	//	HANDLE_OTHER_INST(53, VAArg  , VAArgInst  )  // vaarg instruction
	//	HANDLE_OTHER_INST(54, ExtractElement, ExtractElementInst)// extract from vector
	//	HANDLE_OTHER_INST(55, InsertElement, InsertElementInst)  // insert into vector
	//	HANDLE_OTHER_INST(56, ShuffleVector, ShuffleVectorInst)  // shuffle two vectors.
	//	HANDLE_OTHER_INST(57, ExtractValue, ExtractValueInst)// extract from aggregate
	//	HANDLE_OTHER_INST(58, InsertValue, InsertValueInst)  // insert into aggregate
	//	HANDLE_OTHER_INST(59, LandingPad, LandingPadInst)  // Landing pad instruction.
	//


		case Instruction::ExtractElement:
			/* FALL THROUGH */

			//Block Terminators

		case Instruction::Ret:
			/* FALL THROUGH */

		case Instruction::Switch:
			/* FALL THROUGH */

		case Instruction::IndirectBr:
			/* FALL THROUGH */

		case Instruction::Invoke:
			/* FALL THROUGH */

		case Instruction::Resume:
			/* FALL THROUGH */

		case Instruction::Unreachable:
			/* FALL THROUGH */

				//Binary operations

		case Instruction::Add:
			/* FALL THROUGH */

		case Instruction::FAdd:
			/* FALL THROUGH */

		case Instruction::Sub:
			/* FALL THROUGH */

		case Instruction::FSub:
			/* FALL THROUGH */

		case Instruction::Mul:
			/* FALL THROUGH */

		case Instruction::FMul:
			/* FALL THROUGH */

		case Instruction::UDiv:
			/* FALL THROUGH */

		case Instruction::SDiv:
			/* FALL THROUGH */

		case Instruction::FDiv:
			/* FALL THROUGH */

		case Instruction::URem:
			/* FALL THROUGH */

		case Instruction::SRem:
			/* FALL THROUGH */

		case Instruction::FRem:
			/* FALL THROUGH */

		default:
		{

			instr=(string)I->getOpcodeName();

		}

	} //Switch ends

	main.append(instr);
	//main.append("(");

	vector<string> arguments;

	//Instruction operands
	for(unsigned int i=0;i<I->getNumOperands();i++)
	{
		//errs()<<*(I->getOperand(i) ->getType())<<" ";

		if(!(I->getOperand(i)->hasName()))
		{ //Cases when operand does not have a name:
		  // 1) Constant operand
			if (ConstantInt *CI = dyn_cast<ConstantInt>(I->getOperand(i)))
				if (CI->getBitWidth()<=64) //Checking for integer bits
				{
					//errs() << CI->getSExtValue()<<",";

					std::stringstream str;
					string s;
					str<<CI->getSExtValue();
					str>>s;

					//main.append(s);
					arguments.push_back(s);
				}
		}
		else
		{
			//errs()<<I->getOperand(i)->getName()<<",";
			//main.append(transformArg(I->getOperand(i)->getName()));
			arguments.push_back(transformArg(I->getOperand(i)->getName()));
		}

	}

	//Output Argument
	if(I->hasName())    // If an instruction outputs result
	{
//		//Type and name of instruction value(what instruction returns)
//		//errs()<<"\n     "<<*(I->getType() )<<" "<<I->getName();
//		main.append(",");
//		main.append(transformArg(I->getName()));
		arguments.push_back(transformArg(I->getName()));
	}

	if(!arguments.empty())
	{
		main.append("(");
		for(int i=0;i<arguments.size();i++)
		{
			main.append(arguments[i]);
			if( (i+1) < arguments.size() )
				main.append(",");

		}
		main.append(")");
	}

	return main;
}

string CiaoLiteral::myName()
{
	return "CiaoLiteral";
}

dummyLiteral::dummyLiteral(string L, operation o, string R,bool f)
{	this->var=L;
	this->val=R;
	this->op=o;
	this->val_isconst=f;
	this->llvmInstr=NULL;
}


dummyLiteral::dummyLiteral()
{
	llvmInstr=NULL;
	errs()<<"In Constructor(default) : "<<myName()<<"\n";
}

dummyLiteral::~dummyLiteral()
{
}
string dummyLiteral::toLiteral()
{
	string oper = "";
	switch(this->op)
	{
		case operation::Assignment:
			oper = "=";
			break;
		case operation::Greater:
			oper = ">";
			break;
		case operation::GreaterEqual:
			oper = ">=";
			break;
		case operation::Less:
			oper = "<";
			break;
		case operation::LessEqual:
			oper = "<=";
			break;
		case operation::Equal:
			oper = "=";
			break;
		case operation::NotEqual:
			oper = "\\=";
			break;
		default:
			errs()<<"\nERROR in dummyLiteral::toLiteral() operation not enumerated\n";

	}
	if(val_isconst)
		return (transformArg(var)+ oper + val);
	else
		return (transformArg(var)+ oper + transformArg(val));
}
bool dummyLiteral::isPhi()
{
	return false;
}
bool dummyLiteral::isRet()
{
	return false;
}
string dummyLiteral::getRetStmtVar()
{
	return std::string();
}

 void dummyLiteral::print()
{
	errs()<<"\t\t"<<toLiteral()<<"\n";
}
string dummyLiteral::getvar()
{
	return var;
}
string dummyLiteral::getval()
{
	return val;
}
void dummyLiteral::setvar(string v)
{
	var=v;
}
void dummyLiteral::setval(string v)
{
	val=v;
}
void dummyLiteral::setop(operation o)
{
	op = o;
}
 set<string> dummyLiteral::ref()
{
	std::set<string> refset;
	if(!val_isconst)
		refset.insert(val);
	if(! (op==operation::Assignment))
		refset.insert(var);
	return refset;
}
 set<string> dummyLiteral::def()
{
	std::set<string> defset;
	if(op==operation::Assignment)
		defset.insert(var);
	return defset;
}

string dummyLiteral::myName()
{
	return "dummyLiteral";
}

}
