/*
 * CiaoLiteral.h
 *
 *  Created on: Jun 9, 2014
 *      Author: umer
 */

#ifndef CIAOLITERAL_H_
#define CIAOLITERAL_H_

#include "llvm/IR/Instructions.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/IR/Constants.h"
#include "llvm/IR/GlobalVariable.h"

#include "Globals.h"

#include <vector>
#include <set>

using namespace std;
using namespace llvm;

namespace LLVM2CIAO {

class CiaoLiteral//: public ilist_node<CiaoLiteral>
{
protected:
	Instruction * llvmInstr;

public:

	CiaoLiteral(Instruction * I);

	CiaoLiteral();
	virtual ~CiaoLiteral();

	Instruction * getllvmInstr();
	virtual set<string> def();
	virtual set<string> ref();

	virtual void print();

	virtual bool isPhi();

	virtual bool isRet();

	virtual string getRetStmtVar();

	void instruction_info(string &instr, set<string> &def,set<string> &ref);

	string icmp2literal();

	string call2literal();

	string branch2literal();

	virtual string toLiteral();

	virtual string myName();

};

class dummyLiteral : public CiaoLiteral
{
	string var;// always a variable name
	string val;// can be a constant
	//string op;// assignment or test e.g., =, >, <, etc.

	bool val_isconst;
public:
	enum operation {Assignment,Greater,GreaterEqual,Less, LessEqual,Equal,NotEqual} op;

	dummyLiteral(string L, operation o, string R,bool f);

	dummyLiteral();

	~dummyLiteral();

	virtual string toLiteral();

	virtual bool isPhi();

	virtual bool isRet();

	virtual string getRetStmtVar();

	virtual void print();

	string getvar();

	string getval();

	void setvar(string v);

	void setval(string v);

	void setop(operation o);

	virtual set<string> ref();

	virtual set<string> def();

	virtual string myName();

};

}

#endif /* CIAOLITERAL_H_ */
