/*
 * CiaoModule.h
 *
 *  Created on: Jul 6, 2017
 *      Author: umer
 */

#ifndef CIAOMODULE_H_
#define CIAOMODULE_H_

#include "llvm/IR/Module.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/IR/Constants.h"
#include "llvm/Analysis/LoopInfo.h"

#include "Globals.h"
#include "CiaoFunction.h"

#include <vector>
#include <set>
#include <fstream>

using namespace std;
using namespace llvm;

namespace LLVM2CIAO {

class CiaoModule
{
	Module * llvmModule;
	map<std::string, CiaoFunction *> ciaoFunctions;
	void clearFunctions();
public:

	CiaoModule();
	CiaoModule(Module * MM, ModulePass * MP);
	~CiaoModule();
	Module * getllvmModule();

	void setllvmModule(Module* MM, ModulePass * MP);
	void printAssertions(raw_ostream & OS);
	void printPackages(raw_ostream & OS);
	void print(raw_ostream &O);
};

}

#endif /* CIAOMODULE_H_ */






