/*
 * Globals.cpp
 *
 *  Created on: Jul 6, 2017
 *      Author: umer
 */
#include "Globals.h"


namespace LLVM2CIAO
{


std::map<std::string, std::pair<std::string, std::set<string> > > mergedBlocksNames;

  cl::opt<string> OutputFilename("of", cl::desc("Specify output filename"), cl::value_desc("filename"));

  cl::opt<string> AssertionFilename("assrt", cl::desc("Specify frontend assertion filename"), cl::value_desc("filename"));

  cl::opt<string> DefaultModel("default_model", cl::desc("Include default model"), cl::value_desc("include_defaul_model"));

  cl::opt<string> PackagesFilename("pkg", cl::desc("Specify filename containing packages to be included in the transformed program"), cl::value_desc("filename"));

  cl::opt<string> LoopTransformOption("transform_nested_loop", cl::desc("Specify y/n to perform nested loops are transformation into functions"), cl::value_desc("option"));


template<typename Out>
void split(const std::string &s, char delim, Out result) {
    std::stringstream ss;
    ss.str(s);
    std::string item;
    while (std::getline(ss, item, delim)) {
        *(result++) = item;
    }
}
std::vector<std::string> split(const std::string &s, char delim) {
    std::vector<std::string> elems;
    split(s, delim, std::back_inserter(elems));
    return elems;
}


bool replace(std::string& str, const std::string& from, const std::string& to) {
    size_t start_pos = str.find(from);
    if(start_pos == std::string::npos)
        return false;
    str.replace(start_pos, from.length(), to);
    return true;
}

void replaceAll(std::string& str, const std::string& from, const std::string& to) {
    if(from.empty())
        return;
    size_t start_pos = 0;
    while((start_pos = str.find(from, start_pos)) != std::string::npos) {
        str.replace(start_pos, from.length(), to);
        start_pos += to.length(); // In case 'to' contains 'from', like replacing 'x' with 'yx'
    }
}


string getNewVar()
{
	static int var_counter=0;
	var_counter++;
	return "Y"+std::to_string(var_counter);
}
string transformArg(string arg)
{
	replaceAll(arg, ".", "_");
	replaceAll(arg, " ", "_");
	arg[0]=toupper(arg[0]);
	return arg;
}
string transformBlockName(string bname)
{
	replaceAll(bname, ".", "_");
	replaceAll(bname, " ", "_");
	//bname[0]=tolower(bname[0]);
	return bname;
}

string prefixedBlockName(BasicBlock *b)
{
	string name="";
	if(b)
	{
		std::string func_name=b->getParent()->getName();
		name=b->getName();
		name=func_name+"_"+name;
	}
	return name;
}
}
