/*
 * Globals.h
 *
 *  Created on: Jul 6, 2017
 *      Author: umer
 */

#ifndef GLOBALS_H_
#define GLOBALS_H_


#include "llvm/IR/BasicBlock.h"
#include "llvm/IR/Function.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/Support/CommandLine.h"

#include <sstream>
#include <set>

using namespace std;
using namespace llvm;



namespace LLVM2CIAO
{

//map<blockname,pair<mergedblockname,argumentset>>
//map<foo_bb11,pair<foo_bb11_foo_bb14,{.0,.01,.02,.2,tmp10}>>
extern std::map<std::string, std::pair<std::string, std::set<string> > > mergedBlocksNames;

extern  cl::opt<string> OutputFilename;//("of", cl::desc("Specify output filename"), cl::value_desc("filename"));
extern  cl::opt<string> AssertionFilename;//("assrt", cl::desc("Specify frontend assertion filename"), cl::value_desc("filename"));
//Following is obsolete.
extern  cl::opt<string> DefaultModel;//("default_model", cl::desc("Include default model"), cl::value_desc("include_defaul_model"));
extern  cl::opt<string> PackagesFilename;//("pkg", cl::desc("Specify filename containing packages to be included in the transformed program"), cl::value_desc("filename"));
extern  cl::opt<string> LoopTransformOption;

template<typename Out>
void split(const std::string &s, char delim, Out result);


std::vector<std::string> split(const std::string &s, char delim) ;

bool replace(std::string& str, const std::string& from, const std::string& to) ;

void replaceAll(std::string& str, const std::string& from, const std::string& to);


string getNewVar();

string transformArg(string arg);

string transformBlockName(string bname);

string prefixedBlockName(BasicBlock *b);


}
#endif /* GLOBALS_H_ */
