:- module(_, [run/0], []).

% LLVM_BIN=/usr/local/Cellar/llvm/3.9.0/bin
% clang=$LLVM_BIN/clang
% opt=$LLVM_BIN/opt
% pass=../build-llvm/LLVM2CIAO/libLLVM2CIAO.so
% 
% $clang -S -emit-llvm -o loop.ll -c loop.c
% $opt -analyze -load $pass -mem2reg -break-crit-edges -loop-simplify -instnamer -emit-ciao loop.ll -of loop_out.pl -pkg dummy_pkg

:- use_module(ciao_llvm(ciao_llvm)).
:- use_module(library(process)).

test('concat.c').
test('fact.c').
test('fibonacci.c').
test('listfact.c').
test('loop.c').
test('selectionsort.c').

run :-
	( test(X),
	  run1(X),
	  fail
	; true
	).

run1(In) :-
	atom_concat(Base, '.c', In),
	atom_concat(Base, '.assrt', Assrt),
	atom_concat(Base, '.ll', IR),
	atom_concat(Base, '.new.pl', Out),
	atom_concat(Base, '.out.pl', OldOut),
	( compile_c(In, IR),
	  translate_llvmIR(IR, Out, Assrt),
	  process_call(path(diff), ['-q', Out, OldOut], [status(0)]) ->
	    R = 'Ok'
	; R = '?'
	),
	display(In), display(': '), display(R), nl.

% LLVM_BIN=/usr/local/Cellar/llvm/3.9.0/bin
% clang=$LLVM_BIN/clang
% opt=$LLVM_BIN/opt
% pass=../build-llvm/LLVM2CIAO/libLLVM2CIAO.so
% 
% $clang -S -emit-llvm -o loop.ll -c loop.c
% $opt -analyze -load $pass -mem2reg -break-crit-edges -loop-simplify -instnamer -emit-ciao loop.ll -of loop_out.pl -pkg dummy_pkg
