:- module(tclp_dc_test, 
	[
	    main/0,
	    test/0
	]).


:- use_module(fibo_tclp_dc, [test/1,result/1]).
:- use_package(library(difference_constraints)).

main :- test.

programs([
	fibo_tclp_dc
	 ]).

%Gets all the benchmarks
test :-
	nl, display('=== TCLP(dc) results are ==='), nl,
	programs(Ps),
	member(P,Ps),
 	P:test(L1),
 	P:result(L2),
	L1 #= L2,
 	check(P,L1,L2),
	fail.

test.

check(Name,L1,L2) :-
	L1 #= L2, !,
	display(Name), display('\t working OK'), nl.

check(Name,L1,L1) :- !,
	display(Name), display('\t working OK'), nl.

check(Name,L1,L2) :- 
	check_outputs(L1,L2), !,
	display(Name), display('\t working OK'), nl.

check(Name,_,_) :- 
	display(Name), display('\t NOT working'), nl.

check_outputs(L1,L2) :- 
	length(L1,N1),
	length(L2,N2),
 %% 	display(N1), nl,
 %% 	display(N2), nl,
	N1 = N2,
	!, check_outputs_list(L1,L2).

check_outputs_list([A|La], [B|Lb]) :-
	check(_,A,B),
	check_outputs_list(La,Lb).

check_outputs_([],_,_) :- !.
check_outputs_([H|R],L1,L2) :-
	count_atom(H,L1,N1),
	count_atom(H,L2,N2),
	N1 = N2,
	check_outputs_(R,L1,L2).

count_atom(_,[],0) :- !.
count_atom(H,[H|R],N1) :- !,
	count_atom(H,R,N2),
	N1 is N2 + 1.
count_atom(H,[_|R],N) :- !,
	count_atom(H,R,N).



